#ifndef MY_WORLD_H
#define MY_WORLD_H

class PhysicsElement;// incomplete class declaration to deal with circular class definition
                     // also known as Forward declaration
class Ball;
class Container;
class Spring;

#include <vector>
#include <ostream>
#include <iostream>  // needed by cout
using namespace std;

class MyWorld {
private:
   ostream & out;
   vector<PhysicsElement*> elements;  // array to hold everything in my world.
   vector<const PhysicsElement*> collidingElements; //array usado para contener elementos que colisionan con una bola
public:
   MyWorld(ostream & output=cout);
   void addElement(PhysicsElement *e);
   void printStateDescription();
   void printState(double t);
   void simulate (double delta_t, double endTime, double samplingTime);
   vector<const PhysicsElement*> findCollidingBall(Ball * me); //entrega vector con elementos que colisionan bola, sirve para detectar choque con 2 murallas, o choque con bola y muralla.
};
#endif