#ifndef CONTAINER_H
#define CONTAINER_H
#include <string>
#include <vector>
#include "PhysicsElement.h"
#include "CVector.h"
#include "Wall.h"

//#define NUM_WALLS 4
class Ball;

class Container: public PhysicsElement{
private: 
   static int id;
   //Wall walls[NUM_WALLS]; // other options are possible 
   CVector uLP,dRP;
   vector<Wall> walls;
  // Container();   // nobody can create an instance without state
public:
   Container(CVector upLeftPosition, CVector downRightPosition);
   vector<Wall> getCollidingWalls(Ball * b)const;
   virtual const PhysicsElement* collideWith(const Ball * pb)const;
   virtual string getDescription()const;
   virtual string getState()const;
};
#endif